﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace IGDocumentation
{
    public class CarsBusinessLogic
    {
        public ObservableCollection<Car> GetCars()
        {
            ObservableCollection<Car> carList = new ObservableCollection<Car>();
            carList.Add(new Car(true, "Ram", 22050.00, 153));
            carList.Add(new Car(false, "Explorer", 27175.00, 96));
            carList.Add(new Car(true, "Ram", 35600.00, 42));
            carList.Add(new Car(false, "Camry", 20790.99, 131));

            return carList;
        }
    }

    public class Car : INotifyPropertyChanged
    {
        bool m_isChecked;
        string m_model;
        double m_baseprice;
        int m_mileage;

        public Car()
        {
        }

        public Car(bool isChecked, string model, double baseprice, int mileage)
        {
            this.IsChecked = isChecked;
            this.Model = model;
            this.BasePrice = baseprice;
            this.Mileage = mileage;
        }

        public bool IsChecked
        {
            get { return m_isChecked; }
            set
            {
                if (m_isChecked != value)
                {
                    m_isChecked = value;
                    OnPropertyChanged("Make");
                }
            }
        }

        public string Model
        {
            get { return m_model; }
            set
            {
                if (m_model != value)
                {
                    m_model = value;
                    OnPropertyChanged("Model");
                }
            }
        }

        public double BasePrice
        {
            get { return m_baseprice; }
            set
            {
                if (m_baseprice != value)
                {
                    m_baseprice = value;
                    OnPropertyChanged("BasePrice");
                }
            }
        }

        public int Mileage
        {
            get { return m_mileage; }
            set
            {
                if (m_mileage != value)
                {
                    m_mileage = value;
                    OnPropertyChanged("Mileage");
                }
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }

}